<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex1.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex1.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex1.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex1.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 1: A Good First Program</h1>
                <div class="warning">
<p class="first admonition-title">Warning</p>
<p class="last">If you skipped Exercise 0 then you are not doing this book right.  You must read every single thing I write here and read it carefully.  For example, are you trying to use Python 3 for this book?  I said in Exercise 0 to not use Python 3, so you should <em>not</em> use Python 3.  Are you trying to use IDLE or an IDE?  I said not to use one in Exercise 0, so you should not use one.  If you skipped Exercise 0 please go back to it and read it.</p>
</div>
<p>You should have spent a good amount of time in Exercise 0 learning how to install a text editor, run the text editor, run the Terminal, and work with both of them.  If you haven't done that, then do not go on. You will not have a good time.  This is the only time I'll start an exercise with a warning that you should not skip or get ahead of yourself.</p>
<p>Type the following text into a single file named <tt class="docutils literal">ex1.py</tt>.  Python works best with files ending in <tt class="docutils literal">.py</tt>.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6
7</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex1.py-idio.html-1"></a><span class="k">print</span> <span class="s2">&quot;Hello World!&quot;</span>
<a name="python--ex1.py-idio.html-2"></a><span class="k">print</span> <span class="s2">&quot;Hello Again&quot;</span>
<a name="python--ex1.py-idio.html-3"></a><span class="k">print</span> <span class="s2">&quot;I like typing this.&quot;</span>
<a name="python--ex1.py-idio.html-4"></a><span class="k">print</span> <span class="s2">&quot;This is fun.&quot;</span>
<a name="python--ex1.py-idio.html-5"></a><span class="k">print</span> <span class="s1">&#39;Yay! Printing.&#39;</span>
<a name="python--ex1.py-idio.html-6"></a><span class="k">print</span> <span class="s2">&quot;I&#39;d much rather you &#39;not&#39;.&quot;</span>
<a name="python--ex1.py-idio.html-7"></a><span class="k">print</span> <span class="s1">&#39;I &quot;said&quot; do not touch this.&#39;</span>
</pre></div>
</td></tr></table><p>Your <tt class="docutils literal">Atom</tt> text editor should look something like this on all platforms:</p>
<div class="figure align-center">
<img alt="_static/python/osx_atom.png" src="_static/python/osx_atom.png" />
</div>
<p>Don't worry if your editor doesn't look exactly the same, it should be close though.  You may have a slightly different window header, maybe slightly different colors, and the left side of your <tt class="docutils literal">Atom</tt>
window won't say &quot;zedshaw&quot; but will instead show the directory you used for saving your files.  All of those differences are fine.</p>
<p>When you create this file, keep in mind these points:</p>
<ol class="arabic simple">
<li>I did not type the line numbers on the left. Those are printed in the book so I can talk about specific lines by saying, &quot;See line 5...&quot;  You do not type line numbers into Python scripts.</li>
<li>I have the <tt class="docutils literal">print</tt> at the beginning of the line and it looks exactly the same as what I have in <tt class="docutils literal">ex1.py</tt>.  Exactly means exactly, not kind of sort of the same.  Every single character has to match for it to work. Color doesn't matter, only the characters you type.</li>
</ol>
<p>In Terminal <em>run</em> the file by typing:</p>
<pre class="code console literal-block">
<span class="generic output">python ex1.py</span>
</pre>
<p>If you did it right then you should see the same output as I in the <em>What You Should See</em> section of this exercise. If not, you have done something wrong.  No, the computer is not wrong.</p>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<p>On Mac OS X in the Terminal you should see this:</p>
<div class="figure align-center">
<img alt="_static/python/osx_terminal_ex1.png" src="_static/python/osx_terminal_ex1.png" />
</div>
<p>On Windows in PowerShell you should see this:</p>
<div class="figure align-center">
<img alt="_static/python/win_powershell_ex1.png" src="_static/python/win_powershell_ex1.png" />
</div>
<p>You may see different names, before the <tt class="docutils literal">python ex1.py</tt> command, but the important part is that you type the command and see the output is the same as mine.</p>
<p>If you have an error it will look like this:</p>
<pre class="literal-block">
$ python ex/ex1.py
  File &quot;ex/ex1.py&quot;, line 3
    print &quot;I like typing this.
                             ^
SyntaxError: EOL while scanning string literal
</pre>
<p>It's important that you can read these error messages because you will be making many of these mistakes.  Even I make many of these mistakes.  Let's look at this line by line.</p>
<ol class="arabic simple">
<li>We ran our command in the Terminal to run the <tt class="docutils literal">ex1.py</tt> script.</li>
<li>Python tells us that the file <tt class="docutils literal">ex1.py</tt> has an error on line 3.</li>
<li>It prints this line of code for us to see it.</li>
<li>Then it puts a <tt class="docutils literal">^</tt> (caret) character to point at where the problem is.  Notice the missing <tt class="docutils literal">&quot;</tt> (double-quote) character?</li>
<li>Finally, it prints out a &quot;SyntaxError&quot; and tells us something about what might be the error.  Usually these are very cryptic, but if you copy that text into a search engine, you will find someone else who's had that error and you can probably figure out how to fix it.</li>
</ol>
<div class="warning">
<p class="first admonition-title">Warning</p>
<p>If you are from another country, and you get errors about ASCII encodings, then put this at the top of your Python scripts:</p>
<pre class="literal-block">
# -*- coding: utf-8 -*-
</pre>
<p class="last">It will fix them so that you can use Unicode UTF-8 in your scripts without a problem.</p>
</div>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<p>The Study Drills contain things you should <em>try</em> to do.  If you can't, skip it and come back later.</p>
<p>For this exercise, try these things:</p>
<ol class="arabic simple">
<li>Make your script print another line.</li>
<li>Make your script print only one of the lines.</li>
<li>Put a <tt class="docutils literal">#</tt> (octothorpe) character at the beginning of a line.  What did it do?  Try to find out what this character does.</li>
</ol>
<p>From now on, I won't explain how each exercise works unless an exercise is different.</p>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">An &quot;octothorpe&quot; is also called a &quot;pound&quot;, &quot;hash&quot;, &quot;mesh&quot;, or any number of names.  Pick the one that makes you chill out.</p>
</div>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<p>These are <em>actual</em> questions that real students have asked when doing this exercise.</p>
<dl class="docutils">
<dt>Can I use IDLE?</dt>
<dd>No, you should use Terminal on OS X and PowerShell on Windows, just like I have here.  If you don't know how to use those, then you can go read the Command Line Crash Course in Appendix A.</dd>
<dt>How do you get colors in your editor?</dt>
<dd>Save your file first as a <tt class="docutils literal">.py</tt> file, such as <tt class="docutils literal">ex1.py</tt>.  Then you'll have color when you type.</dd>
<dt>I get <tt class="docutils literal">SyntaxError: invalid syntax</tt> when I run ex1.py.</dt>
<dd>You are probably trying to run Python, then trying to type Python again.  Close your Terminal, start it again, and right away type only <tt class="docutils literal">python ex1.py</tt>.</dd>
<dt>I get <tt class="docutils literal">can't open file 'ex1.py': [Errno 2] No such file or directory</tt>.</dt>
<dd>You need to be in the same directory as the file you created.  Make sure you use the <tt class="docutils literal">cd</tt> command to go there first.  For example, if you saved your file in <tt class="docutils literal">lpthw/ex1.py</tt>, then you would do <tt class="docutils literal">cd lpthw/</tt> before trying to run <tt class="docutils literal">python ex1.py</tt>.  If you don't know what any of that means, then go through <em>Appendix A</em>.</dd>
<dt>How do I get my country's language characters into my file?</dt>
<dd>Make sure you type this at the top of your file: <tt class="docutils literal"># <span class="pre">-*-</span> coding: <span class="pre">utf-8</span> <span class="pre">-*-</span></tt>.</dd>
<dt>My file doesn't run; I just get the prompt back with no output.</dt>
<dd>You most likely took the code in my <tt class="docutils literal">ex1.py</tt> file literally and thought that <tt class="docutils literal">print &quot;Hello World!&quot;</tt> meant to type only <tt class="docutils literal">&quot;Hello World!&quot;</tt> into the file, without the <tt class="docutils literal">print</tt>.  Your file has to be <em>exactly</em> like mine.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex1.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex1.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
